! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
      subroutine bdfi4w(i4arr,nelem1,nelem2,output,refnam,ident, &
                        ierr)

      use dal
      use cp_head_mod

      implicit none

      integer, intent(IN) :: nelem1, nelem2, ierr      
      integer(kind=int32), dimension(nelem1,nelem2), intent(IN) :: i4arr
      character(len=*), intent(IN) :: output, refnam, ident

      integer(kind=int32), dimension(:,:), pointer :: i4arr0

      integer :: ix, iy 
      integer, dimension(2) :: npix

      
      type(DataSetT) :: set, set0
      Type(ArrayT) :: arr

      npix(1)  = nelem1
      npix(2)  = nelem2

      set = dataset(output, write)
      arr = addArray(set, "PRIMARY",integer32, npix)
      i4arr0 => int32array2data(arr)
      do ix=1,nelem1
        do iy=1,nelem2
          i4arr0(ix-1,iy-1)=i4arr(ix,iy)
        end do
      end do  
      set0 = dataset(refnam, read)
      call cp_head (set0, set, ident, 2)

      call release(set0)
      call release(arr)
      call release(set)   

      return
      end
