! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
      !--------------------------------------------------------------------
      subroutine bdfl4r(l4arr,nelem1,nelem2,output,no,start,step,npix,ierr)
      !--------------------------------------------------------------------

      use dal
      use global
      use cgenl

      implicit none

!      include 'include/cgenl_f90.cmn'

      integer     maxdim,naxis,ix,iy
      parameter   (maxdim=2)
      integer npix(maxdim)
      integer     nelem1, nelem2, no, ierr
      logical, dimension(nelem1,nelem2) :: l4arr
      double precision start(maxdim),step(maxdim)
      character*(*) output

      type(datasett) :: set
      type(arrayt) :: arr
      integer, dimension(:,:), pointer :: i4arr0
      integer, dimension(:), pointer :: npixp 

      set = dataset (output, read)
      arr = array(set, "PRIMARY", read)
      i4arr0 => int32array2data(arr)
      npix(1) = 640 ! int16attribute(arr,"naxis1")
      npix(2) = 640 ! int16attribute(arr,"naxis2")
!      npixp = arraysize(arr)
!      npix = npixp 
      do ix=1,npix(1)
        do iy=1,npix(2)
          if (i4arr0(ix-1,iy-1) == 0) then
            l4arr(ix,iy) = .false.
          else
            l4arr(ix,iy) = .true.
          end if 
        end do
      end do
      start(1) = 1d0
      start(2) = 1d0
      step(1) = 1d0
      step(2) = 1d0

      call release(arr)
      call release(set)

      end subroutine bdfl4r
