! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
      !--------------------------------------------------------------------
      subroutine bdfr4r(output,filetype,no,start,step,xcen,ycen,npix,inst,ierr)
      !--------------------------------------------------------------------

      use dal
      use global
      use cgenl

      implicit none

!      include 'include/cgenl_f90.cmn'

      integer     maxdim,naxis,ix,iy
      parameter   (maxdim=2)
      integer     npix(maxdim)
      integer, intent(out) :: xcen, ycen
      character(len=1024), intent(in) :: inst
      integer     no, ierr
!      real        r4arr(nelem1,nelem2)
!      real, allocatable :: r4arr(:,:)
      double precision start(maxdim),step(maxdim)
      character(1024) :: ins1
      character(*) :: filetype
      character*(*) output
 
      type(datasett) :: set
      type(arrayt) :: arr
      integer, dimension(:), pointer :: shape
      real(kind=single), dimension(:,:), pointer :: r4arr0

      set = dataset (output, read)
      arr = array(set, "PRIMARY", read)

      if (hasAttribute(set,"INSTRUME")) then 
        ins1 = stringAttribute(set,"INSTRUME")
      else if (hasAttribute(arr,"INSTRUME")) then
          ins1 = stringAttribute(arr,"INSTRUME")
      end if 
      if (trim(inst) /= trim(ins1)) &
        call error ("FileMismatch","Exposure map has wrong instrument") 

    if (hasAttribute(set,"XCEN")) then
      xcen = real32Attribute(set,"XCEN")
    else if (hasAttribute(arr,"XCEN")) then
      xcen = real32Attribute(arr,"XCEN")
    end if
    if (hasAttribute(set,"XCEN")) then
      xcen = real32Attribute(set,"XCEN")
    else if (hasAttribute(arr,"XCEN")) then
      xcen = real32Attribute(arr,"XCEN")
    end if
    if (hasAttribute(set,"YCEN")) then
      ycen = real32Attribute(set,"YCEN")
    else if (hasAttribute(arr,"YCEN")) then
      ycen = real32Attribute(arr,"YCEN")
    end if
    if (hasAttribute(set,"YCEN")) then
      ycen = real32Attribute(set,"YCEN")
    else if (hasAttribute(arr,"YCEN")) then
      ycen = real32Attribute(arr,"YCEN")
    end if

      r4arr0 => real32array2data(arr)
      shape => dimensions(arr)
      npix(1) = shape(0)
      npix(2) = shape(1)
      ipa_x = npix(1)
      ipa_y = npix(2)
      idm_x = ipa_x
      idm_y = ipa_y


      if (filetype .eq. "expmap") then
        allocate (iexmp(ipa_x,ipa_y))     
        do ix=1,npix(1)
          do iy=1,npix(2)
            iexmp(ix,iy) = r4arr0(ix-1,iy-1)
          end do
        end do
        start(1) = 1d0
        start(2) = 1d0
        step(1) = 1d0
        step(2) = 1d0

        call release(arr)
        call release(set)
      elseif (filetype .eq. "expmap2") then 
        allocate (iexmp2(ipa_x,ipa_y))     
        do ix=1,npix(1)
          do iy=1,npix(2)
            iexmp2(ix,iy) = r4arr0(ix-1,iy-1)
          end do
        end do
        start(1) = 1d0
        start(2) = 1d0
        step(1) = 1d0
        step(2) = 1d0

        call release(arr)
        call release(set)       
      endif
      

      
      end subroutine bdfr4r
