C ESA (C) 2000-2018 
C
C This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
C
C    SAS is free software: you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation, either version 3 of the License, or
C    (at your option) any later version.
C
C    SAS is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License
C    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
      SUBROUTINE CHEESE(IERR)
C
CC  folds image with blinded exposure
C
C************************ FFORM VERSION 1.1 ************  7-NOV-89 15:12
C
CA  author : GRH        date: 1-DEC-1986 17:53
CU  update : CRI        date: 2-FEB-1988 17:07
CU  update : PTK        date: 16-SEP-1988 15:13
CU  update : PTK        date: 11-OCT-1988 18:12
CU  update : PTK        date: 11-OCT-1988 18:28
CU  update : PTK        date: 16-MAR-1989 10:15
CU  update : PTK        date: 16-MAR-1989 10:26
CU  update : PTK        date: 16-MAR-1989 11:06
CU  update : PTK        date: 19-FEB-1990 07:41
CU  update : PTK        date: 12-DEC-1991 19:29 MFELD L*4 -> I*4
CU  update : EXSAS              date: 03-AUG-1993 16:49
C
CT  status: not tested
C
C   general description 
CG  folds image with blinded exposure map 
C
C   call_var.          type I/O description 
CP  IERR                I4    O error code
CP                              no error
C
C   include_block name          description 
CI  RCOMMON:CGENL.CMN           general parameter common block
CI  RCOMMON:CDBIMG.CMN          IMPAR parameter common block
C
C   routines_called    type     description 
CR  HFLAG               R4      output flag handling routine
CR  WRFLAG              SR      writes to FLAG output stream
C
C   extensions/system calls     description 
CX 
C
C***********************************************************************
C
C   variables   meaning
C
C
      use global 

      IMPLICIT NONE
      INCLUDE 'include/cgenl.cmn'
!     INCLUDE 'include/cdbimg.cmn'
C
      CHARACTER*8   RTNAME
      INTEGER     I, IERR, IOS, J, NTRUE
      REAL        HFLAG
C
      SAVE
      DATA          RTNAME /'CHEESE'/
C
      IERR=0
      NTRUE = 0
C
C!-   fold image file with blinded exposure map
C
      DO J=1,IDM_Y
        DO I=1,IDM_X
          IF(MFELD(I,J).EQ.1)THEN
            NTRUE = NTRUE + 1
            ICHES(I,J)=IFELD(I,J)
          ELSE
            ICHES(I,J)=0.0
          ENDIF
        ENDDO
      ENDDO
C
C
CH!  DB  -  BACKGROUND
C
      RETURN
      END
