! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
module cp_head_mod

  use dal

  implicit none

contains

  !---------------------------------------------------------------------
  subroutine cp_attr (set1, set2, arr, attr)
  !---------------------------------------------------------------------

    type(DataSetT), intent(IN) :: set1, set2
    type(ArrayT), intent(IN) :: arr
    character(len=*), dimension(:), intent(IN) :: attr

    integer i

    do i=1,size(attr)
      if (hasAttribute(set1,attr(i))) then
        call setAttribute(set2,attribute(set1,attr(i)))
      else 
        if (hasAttribute(arr,attr(i))) then
          call setAttribute(set2,attribute(arr,attr(i)))
        end if
      end if
    end do

  end subroutine

  !---------------------------------------------------------------------
  subroutine cp_head (set1, set2, content, mod)
  !---------------------------------------------------------------------

    type(DataSetT), intent(IN) :: set1, set2
    type(ArrayT) :: arr, arr2
    character(len=*), intent (IN) :: content
    integer, intent(IN) :: mod

    arr = array (set1,"PRIMARY",read)

    !!! IT 2014/05
    !!! copy full dataset header and array header of images
    call setAttributes( attributable(set2), attributable(set1) )
    arr2 = array(set2,0)
    call setAttributes( attributable(arr2), attributable(arr) )
    call release(arr2)

!!!    if (mod > 0) then
!!!      call cp_attr(set1,set2,arr,(/"INSTRUME","DETNAME "/) )
!!!    end if
!!!
!!!    if (mod == 2) then
!!!      call cp_attr(set1,set2,arr,(/"BAND"/) )
!!!    end if
!!!
!!!    call cp_attr(set1,set2,arr, &
!!!    (/ "TELESCOP","DATAMODE","FILTER  ","OBS_MODE","OBS_ID  ","EXP_ID  ", &
!!!       "ORIGIN  ","OBJECT  ","RA_PNT  ","DEC_PNT ","ROLL_PNT", &
!!!       "CRPIX1  ","CRPIX2  ","CRVAL1  ","CRVAL2  ","CDELT1  ", &
!!!       "CDELT2  ","CTYPE1  ","CTYPE2  ","RADECSYS","EQUINOX ", &
!!!       "EXPOSURE","DATE-OBS","DATE-END","OBSERVER"/) )

    call setAttribute(set2,"CONTENT", content, "Content of file")

    call release(arr)

  end subroutine cp_head

end module
