! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
  !---------------------------------------------------------------------
  subroutine dbpari    
  !---------------------------------------------------------------------

    use param
    use global
    use cgenl


    implicit none
!    include 'include/cgenl_f90.cmn'
    include 'include/cdbio_f90.cmn'
!!   include 'include/cdbimg_f90.cmn'
!    include 'include/clslst_f90.cmn'

    dbexpd = 'XMM-EPIC'
    dbobsm = 'pointing'
!    det_id = 'XMM'

    ict_ech = 1

    image(1) = stringParameter("imageset")
    expima(1) = stringParameter("expimageset")
    expima2(1) = stringParameter("expimageset2")
    lslst(1) = stringParameter("boxlistset")
    bacmp(1) = stringParameter("bkgimageset")
    cheeseim = stringParameter("cheeseimageset")
    cheesemask= stringParameter("cheesemaskset")
    ootlist  = stringParameter("ooteventset")
    withoot = booleanParameter("withootset")
    method =  stringParameter("fitmethod")
    db_lmap = booleanParameter("withdetmask")    
    mexbm = stringParameter("detmaskset")
    db_exp = booleanParameter("withexpimage")
    db_exp2 = booleanParameter("withexpimage2")
    db_cheese = booleanParameter("withcheese")
    db_cheesemask =  booleanParameter("withcheesemask")
    db_nstp = intParameter("nfitrun")
    db_nspline = intParameter("nsplinenodes")    
    db_esig = realParameter("excesssigma")
    db_snrm = realParameter("mlmin")
    db_cut = realParameter("scut")
    db_band = intParameter("idband")
    db_snrmin = realParameter("snrmin")         !!! IT 2016/01: fitmethod smooth
    db_smoothsigma = realParameter("smoothsigma")           !!! fitmethod smooth
    pimin = intParameter("pimin")
    pimax = intParameter("pimax")

    if (method .eq. 'model' .and. .not. db_exp) then
      call error("ParamMismatch","Need  exposure map for fitmethod *model*")
    endif


    db_nres = 1
    bscal = 1.0
    db_fof = .false.

!   dbfwhm (fwhm_cal_file)



  end subroutine dbpari








