C ESA (C) 2000-2018 
C
C This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
C
C    SAS is free software: you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation, either version 3 of the License, or
C    (at your option) any later version.
C
C    SAS is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License
C    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
      FUNCTION EPSMIN(XOMAS,YOMAS,PIXEL)
C
CC  get off-axis position
C
C************************ FFORM VERSION 1.1 ************  7-NOV-89 15:12
C
CA  author : CRI        date: 21-MAR-1988 12:03
CU  update : CRI        date: 15-APR-1988 12:13
CU  update : PTK        date: 16-SEP-1988 16:30
CU  update : EXSAS              date: 03-AUG-1993 16:50
C
CT  status: not tested
C
C   general description 
CG  compute off-axis position in arc min from x and y omas coordinates
C
C   call_var.          type I/O description 
CP  EPSMIN              R4      off-axis position in arc min
CP  PIXEL               R4  I   arc sec per omas pixel
CP  XOMAS               R4  I   x omas coordinate
CP  YOMAS               R4  I   y omas coordinate
C
C   include_block name          description 
CI  RCOMMON:CGENL.CMN  general parameter common block
CI                              
C
C   routines_called    type     description 
CR  HFLAG               R4      output flag handling routine
CR  WRFLAG              SR      writes to FLAG output stream
C
C   extensions/system calls     description 
CX 
C
C***********************************************************************
C
C   variables   meaning
C
C
      IMPLICIT NONE
      INCLUDE 'include/cgenl.cmn'
C
      REAL        CONV, EPSMIN, HFLAG, PIXEL, XOMAS, YOMAS
      INTEGER     IOS, LOOP
      CHARACTER*8   RTNAME
C
      SAVE
      DATA          LOOP /0/,  RTNAME /'EPSMIN'/
C
      IF(LOOP.EQ.0) THEN
         CONV = PIXEL/60.
         LOOP = 1
      ENDIF
      EPSMIN = SQRT(XOMAS*XOMAS + YOMAS*YOMAS) * CONV
C
      RETURN
      END
