! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
module global


  implicit none 

  integer, parameter :: max_ima = 18
  integer, parameter :: max_ins = 3
  integer, parameter :: max_bands = 6        

  real,    parameter :: ootcut = 2.0    !!! IT 2021/04 threshold of OOT masking
  integer, parameter :: ootpix = 3      !!! IT 2021/04 mask OOTs by +-ootpix px

  integer :: num_instr, idinst
  integer, dimension(max_ins) :: num_image
  integer, dimension(max_ins, max_bands) :: ip
  integer, dimension(2) :: imsize
  

  character(64), dimension(max_ima) :: c_image, c_bgima, c_expima, c_expima2, c_detima
  character(64) :: method
  character(1024)  :: ootlist
  logical        :: withoot

  integer :: pimin, pimax

  integer :: ipa_x, ipa_y, idm_x, idm_y
  integer :: ix0, ix1, iy0, iy1, iusex, iusey     !!! IT 2021/04 for subimages
  real, dimension(:,:), allocatable :: iback,ifeld,oot_sky,jfeld,iches,iexmp,iexmp2
  integer, dimension(:,:), allocatable :: mfeld, msave
  double precision :: crpix1,crpix2,crval1,crval2
  double precision :: crdelt1,crdelt2,crota2,ra_pnt,dec_pnt,pa_pnt
  real, dimension(2) :: backparam


end module global









