! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
module nag_global

! variables from cdbnag.cmn:
!  WNAG             R*8       array with weight values
!  WORK             R*8       work array see NAG description
!  XL               R*8       array with knot X-coordinates
!  XNAG             R*8       array with data X-values
!  YM               R*8       array with knot Y-coordinates
!  YNAG             R*8       array with data Y-values
!-----------------------------------------------------------------------

!!! integer, parameter :: MPX=20, MPY=20, MWORK=27700, MPOINT=8400
!!! integer, parameter ::  MADRES=169, MC=256, MTOT=8192
 integer, parameter :: MPX=40, MPY=40, MWORK=221600, MPOINT=8400
 integer, parameter ::  MADRES=676, MC=2048, MTOT=16384
 double precision, dimension(mwork) :: WORK
 double precision, dimension(mtot) :: XNAG,YNAG,FNAG,WNAG,ENAG,FFNAG,WNAG_SAVE
 double precision, dimension(mtot) :: IMBINNED,EXPBINNED,EXP2BINNED
 double precision, dimension(mpx) :: XL
 double precision, dimension(mpy) :: YM
 double precision, dimension(mc) :: DL, C
 double precision :: EPS, SIGMA, WMIN=0.1D0, SMALL=1.0D-8
 integer*8, dimension(mpoint) :: IPOINT
 integer*8, dimension(madres) :: IADRES
 integer ::  NPX, NPY
 integer*8 ::  NPTS, NWORK, NPOINT, NADRES, NC


end module nag_global
