! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
   real function radi_cal (epsoff, scts, cut1) result (r1)

   use cal

   type (PsfT) :: psfp
   
   real, intent(in) :: epsoff, scts, cut1
   real :: r0, ftest, diff
   real(kind=double) :: frac0, frac1, theta  
   integer :: i

   real, parameter :: pi=3.151592654, mm2sec=3600.0*180.0/(pi*7500.0)

   call CAL_setState1(accuracyLevel=ACCURACY_MEDIUM)

   theta = min(epsoff,899.0)
   psfp = CAL_getPSF(2000d0, theta, 0d0)

   r0 = 0.0
   frac0 = 0.0
   diff = 0.9
   do i = 1,20
     frac1 = 1.0-diff
     r1 = CAL_psfEncircledEnergy(psfp,frac1) * mm2sec 
     ftest = scts*(frac1-frac0) / (PI*(r1**2-r0**2))
     if (ftest < cut1) exit
     r0 = r1
     frac0 = frac1
     diff = diff*0.8
   end do 

   return
   end

