C ESA (C) 2000-2018 
C
C This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
C
C    SAS is free software: you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation, either version 3 of the License, or
C    (at your option) any later version.
C
C    SAS is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License
C    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
C @(#)tiflps.for	1.1 (MPE-Garching) 3/16/94 16:30:12
      SUBROUTINE TIFLPS(DIM,XPIX,YPIX,PIXX,PIXY,STEREO,WIDTH,EPSIL,
     &                  BAU,NODES,TOTNOD,DUMP,SET1,NCOL,
     &                  BISEC,SET2,BUFFER,SET3,RANGE,DSASSO,TET,
     &                  RPANC,VARIA,VARIA2,NORM,IERR)
C
CC  Spline surface
C
C************************ FFORM VERSION 3.0 ********** 31-JAN-90 09:20
C
CA  author : EXSAS              date: 01-DEC-1991 15:01
CU  update : EXSAS              date: 03-AUG-1993 16:52
C
CT  status: not tested
C
C   general description:
CG  Spline surface
C
C   call_var.          type I/O description
CP  IERR                I     O = 0 no error 
CP                              = 3 
C
C   include_block_name          description
CI  RCOMMON:CGENL.CMN           general parameter common block
C
C   routines_called    type     description
CR
C
C   extensions/system calls     description
CX  
C
C***********************************************************************
C
C   variables   meaning
C
      IMPLICIT NONE
C
      INTEGER     RANGE,DIM,NCOL,TOTNOD,XPIX,YPIX,NORM,IERR
cdb      DOUBLE PRECISION
cdb     &        VARIA,VARIA2,SET3(RANGE),SET2(NCOL),SET1(NCOL)
      double precision varia,varia2,set3(*),set2(*),set1(*)
cdb      DOUBLE PRECISION
cdb     &        BISEC(NCOL),DUMP(NCOL),BAU(YPIX)
      double precision bisec(*),dump(*),bau(*)
cdb      DOUBLE PRECISION
cdb     &        DSASSO(NCOL),STEREO(DIM),TET(NCOL),EPSIL(XPIX)
      double precision dsasso(*),stereo(*),tet(*),epsil(*)
      DOUBLE PRECISION
     &        RPANC(NCOL,RANGE),BUFFER(NCOL,RANGE),WIDTH(DIM)
      DOUBLE PRECISION
     &        PIXX(DIM),PIXY(DIM)
      DOUBLE PRECISION
     &        NEWCOL,NEWROW,CROLL,D,GIU,DESTR4,DESTR5,DESTR6
      DOUBLE PRECISION
     &        DESTR7,DESTR8,DESTR9,SINIS4,SINIS5,SINIS6,SINIS7
      DOUBLE PRECISION
     &        SINIS8,SINIS9,ELEM2
      DOUBLE PRECISION
     &        ELEM3,ELEM4,ELEM5,EPSIL1,EPSIL2,EPSIL3,EPSIL4
      DOUBLE PRECISION
     &        EPSIL5,EPSIL6,HELP1,HELP2,M3,MENEFR,BAU1,BAU2,BAU3
      DOUBLE PRECISION
     &        BAU4,BAU5,BAU6,LECCA,POS,S,SROLL,QUADRO,OLDCOL
      DOUBLE PRECISION
     &        OLDROW,IWID,IXPIX,IYPIX
      INTEGER     NODES(TOTNOD),RANGE1,MINRAN,I,PNTR,I2,STORE
      INTEGER     INDICE,J
      INTEGER     J2,SUM,GIN,OLDGIN,VODK,CAPPA,CHIAVE,TOPPA,L
      INTEGER     ELIC,ELSA,L2,ADD,EMPTY,R,SCAN,SONUNO,SONDUE
      INTEGER     TIDUE,Z,WINDOW
      REAL        SPANX(4),SPANY(4)
      CHARACTER*8   RTNAME
C
      SAVE
      DATA          RTNAME /'TIFLPS'/
C
      IERR=0
C
      CHIAVE = XPIX - 4
      ELIC = YPIX - 4
      TOPPA = XPIX - 7
      ELSA = YPIX - 7
      EMPTY = TOPPA*ELSA
      RANGE1 = RANGE - 1
      IERR = 4
      IF (DIM.LE.1 .OR. XPIX.LT.8 
     &    .OR. YPIX.LT.8 .OR. NCOL.NE.CHIAVE*ELIC .OR.
     &    TOTNOD.LT.DIM+EMPTY) RETURN
      HELP1 = PIXX(1)
      HELP2 = HELP1
      DO I = 1,DIM
         IXPIX = PIXX(I)
         IF (IXPIX.GT.HELP1) HELP1 = IXPIX
         IF (IXPIX.LT.HELP2) HELP2 = IXPIX
      ENDDO
      DO I = 1,4
         EPSIL(I) = HELP2
         INDICE = XPIX - I + 1
         EPSIL(INDICE) = HELP1
      ENDDO
      HELP1 = PIXY(1)
      HELP2 = HELP1
      DO I = 1,DIM
         IYPIX = PIXY(I)
         IF (IYPIX.GT.HELP1) HELP1 = IYPIX
         IF (IYPIX.LT.HELP2) HELP2 = IYPIX
      ENDDO
      DO I = 1,4
         BAU(I) = HELP2
         INDICE = YPIX - I + 1
         BAU(INDICE) = HELP1
      ENDDO
      IERR = 1
      DO I = 2,XPIX
         IF (EPSIL(I-1).GT.EPSIL(I)) RETURN
      ENDDO
      DO I = 2,YPIX
         IF (BAU(I-1).GT.BAU(I)) RETURN
      ENDDO
      IERR = 2
      DO I = 1,CHIAVE
         IF (EPSIL(I).EQ.EPSIL(I+4)) RETURN
      ENDDO
      DO I = 1,ELIC
         IF (BAU(I).EQ.BAU(I+4)) RETURN
      ENDDO
      IERR = 5
      DO I = 1,DIM
         IF (WIDTH(I).NE.0.0D0) IERR = 0
      ENDDO
      IF (IERR.NE.0) RETURN
      IERR = 3
      DO I = 1,NCOL
         BISEC(I) = 0
         SET2(I) = 0
         DO J = 2,RANGE
            BUFFER(I,J) = 0
         ENDDO
      ENDDO
      QUADRO = 0
      OLDGIN = 0
      MENEFR = 0
      SONUNO = 0
      DO I = 1,EMPTY
         PNTR = I + DIM
         IF (NODES(PNTR).GT.0) THEN
           GIN = (I-1)/ELSA
           VODK = I - GIN*ELSA
           GIN = GIN + 1
           SCAN = (GIN-1)*ELIC + VODK
           IF (GIN.NE.OLDGIN) THEN
             EPSIL1 = EPSIL(GIN+1)
             EPSIL2 = EPSIL(GIN+2)
             EPSIL3 = EPSIL(GIN+3)
             EPSIL4 = EPSIL(GIN+4)
             EPSIL5 = EPSIL(GIN+5)
             EPSIL6 = EPSIL(GIN+6)
             DESTR4 = 1.0D0/(EPSIL4-EPSIL1)
             DESTR5 = 1.0D0/(EPSIL5-EPSIL2)
             DESTR6 = 1.0D0/(EPSIL6-EPSIL3)
             DESTR7 = 1.0D0/(EPSIL4-EPSIL2)
             DESTR8 = 1.0D0/(EPSIL5-EPSIL3)
             DESTR9 = 1.0D0/(EPSIL4-EPSIL3)
             OLDGIN = GIN
           ENDIF
           BAU1 = BAU(VODK+1)
           BAU2 = BAU(VODK+2)
           BAU3 = BAU(VODK+3)
           BAU4 = BAU(VODK+4)
           BAU5 = BAU(VODK+5)
           BAU6 = BAU(VODK+6)
           SINIS4 = 1.0D0/(BAU4-BAU1)
           SINIS5 = 1.0D0/(BAU5-BAU2)
           SINIS6 = 1.0D0/(BAU6-BAU3)
           SINIS7 = 1.0D0/(BAU4-BAU2)
           SINIS8 = 1.0D0/(BAU5-BAU3)
           SINIS9 = 1.0D0/(BAU4-BAU3)
  1        PNTR = NODES(PNTR)
           IF (PNTR.GT.0) THEN
             DO J = 1,RANGE
                SET3(J) = 0
             ENDDO
             IWID = WIDTH(PNTR)**2
             IF (IWID.EQ.0.0D+0) GO TO 1
             IXPIX = PIXX(PNTR)
             IYPIX = PIXY(PNTR)
             NEWROW = STEREO(PNTR)
             SONUNO = SONUNO + 1
             MENEFR = MENEFR + IWID
             IF (IXPIX.LT.EPSIL3 .OR. IXPIX.GT.EPSIL4 .OR.
     &          (IXPIX.EQ.EPSIL4 .AND. GIN.NE.TOPPA)
     &          .OR. IYPIX.LT.BAU3 .OR. IYPIX.GT.BAU4 .OR.
     &          (IYPIX.EQ.BAU4 .AND. VODK.NE.ELSA)) RETURN
             ELEM5 = EPSIL5 - IXPIX
             ELEM4 = EPSIL4 - IXPIX
             ELEM3 = IXPIX - EPSIL3
             ELEM2 = IXPIX - EPSIL2
             HELP2 = ELEM3*DESTR8*DESTR9
             HELP1 = ELEM4*DESTR7*DESTR9
             M3 = ELEM3*HELP2*DESTR6
             HELP2 = (ELEM2*HELP1+ELEM5*HELP2)*DESTR5
             HELP1 = ELEM4*HELP1*DESTR4
             SPANX(4) = ELEM3*M3
             SPANX(3) = ELEM2*HELP2 + (EPSIL6-IXPIX)*M3
             SPANX(2) = (IXPIX-EPSIL1)*HELP1 + ELEM5*HELP2
             SPANX(1) = ELEM4*HELP1
             ELEM5 = BAU5 - IYPIX
             ELEM4 = BAU4 - IYPIX
             ELEM3 = IYPIX - BAU3
             ELEM2 = IYPIX - BAU2
             HELP2 = ELEM3*SINIS8*SINIS9
             HELP1 = ELEM4*SINIS7*SINIS9
             M3 = ELEM3*HELP2*SINIS6
             HELP2 = (ELEM2*HELP1+ELEM5*HELP2)*SINIS5
             HELP1 = ELEM4*HELP1*SINIS4
             SPANY(4) = ELEM3*M3
             SPANY(3) = ELEM2*HELP2 + (BAU6-IYPIX)*M3
             SPANY(2) = (IYPIX-BAU1)*HELP1 + ELEM5*HELP2
             SPANY(1) = ELEM4*HELP1
             CAPPA = 0
             DO L = 1,4
                LECCA = SPANX(L)
                DO J = 1,4
                   STORE = CAPPA + J
                   SET3(STORE) = LECCA*SPANY(J)
                ENDDO
                CAPPA = CAPPA + ELIC
             ENDDO
             J = SCAN
             DO L2 = 1,RANGE
                L = L2 - 1
                IF (IWID.EQ.0.0D+0) GO TO 1
                POS = SET3(L+1)
                S = IWID*POS
                IF (S*POS.NE.0.0D+0) THEN
                  SUM = J + L
                  MINRAN = RANGE - L
                  D = BISEC(SUM)
                  IF (D.EQ.0.0D+0) THEN
                    BISEC(SUM) = S*POS
                    CROLL = 0
                    SROLL = 1.0D0/POS
                  ELSE
                    GIU = D + S*POS
                    BISEC(SUM) = GIU
                    CROLL = D/GIU
                    SROLL = S/GIU
                  ENDIF
                  IWID = IWID*CROLL
                  IF (MINRAN.GE.2) THEN
                    DO Z = 2,MINRAN
                       ADD = L + Z
                       OLDCOL = BUFFER(SUM,Z)
                       OLDROW = SET3(ADD)
                       BUFFER(SUM,Z) = CROLL*OLDCOL + SROLL*OLDROW
                       SET3(ADD) = OLDROW - POS*OLDCOL
                    ENDDO
                  ENDIF
                  NEWCOL = SET2(SUM)
                  SET2(SUM) = CROLL*NEWCOL + SROLL*NEWROW
                  NEWROW = NEWROW - POS*NEWCOL
                ENDIF
             ENDDO
             QUADRO = QUADRO + IWID*NEWROW**2
             GO TO 1
           ENDIF
         ENDIF
      ENDDO
      HELP1 = SONUNO
      MENEFR = MENEFR/HELP1
      R = 0
      DO I = 1,NCOL
         IWID = BISEC(I)
         DUMP(I) = IWID/MENEFR
         IF (IWID.LE.VARIA*MENEFR) THEN
           BISEC(I) = 0
           R = R + 1
           NEWROW = SET2(I)
           DO L = 2,RANGE
              SET3(L-1) = BUFFER(I,L)
           ENDDO
           SET3(RANGE) = 0
           IF (I.NE.NCOL) THEN
             I2 = I + 1
             DO L = I2,NCOL
                IF (IWID.EQ.0.0D+0) GO TO 2
                POS = SET3(1)
                S = IWID*POS
                WINDOW = NCOL - L + 1
                IF (WINDOW.GT.RANGE) WINDOW = RANGE
                IF (S*POS.NE.0.0D+0) THEN
                  D = BISEC(L)
                  IF (D.EQ.0.0D+0) THEN
                    BISEC(L) = S*POS
                    CROLL = 0
                    SROLL = 1.0D0/POS
                  ELSE
                    GIU = D + S*POS
                    BISEC(L) = GIU
                    CROLL = D/GIU
                    SROLL = S/GIU
                  ENDIF
                  IWID = IWID*CROLL
                  IF (WINDOW.GE.2) THEN
                    DO Z = 2,WINDOW
                       OLDCOL = BUFFER(L,Z)
                       OLDROW = SET3(Z)
                       BUFFER(L,Z) = CROLL*OLDCOL + SROLL*OLDROW
                       SET3(Z-1) = OLDROW - POS*OLDCOL
                    ENDDO
                  ENDIF
                  NEWCOL = SET2(L)
                  SET2(L) = CROLL*NEWCOL + SROLL*NEWROW
                  NEWROW = NEWROW - POS*NEWCOL
                ELSE
                  DO Z = 2,WINDOW
                     SET3(Z-1) = SET3(Z)
                  ENDDO
                ENDIF
                SET3(WINDOW) = 0
             ENDDO
           ENDIF
           QUADRO = QUADRO + IWID*NEWROW**2
         ENDIF
  2      CONTINUE
      ENDDO
      NORM = NCOL - R
      IERR = 5
      IF (NORM.EQ.0) RETURN
      IF (R.NE.0) THEN

        DO I = 1,NORM
           DSASSO(I) = 1.0D0
           DO J = 2,RANGE
              RPANC(I,J) = 0
           ENDDO
        ENDDO
        SONUNO = 0
        WINDOW = 0
        INDICE = NCOL - 1
        DO I2 = 1,INDICE
           I = NCOL - I2
           IF (BISEC(I).NE.0.0D+0) THEN
             WINDOW = I2 + 1
             IF (WINDOW.GT.RANGE) WINDOW = RANGE
             SONDUE = SONUNO + 1
             SONUNO = SONDUE
             TIDUE = 2
             DO J = 2,WINDOW
                STORE = I + J - 1
                IF (BISEC(STORE).NE.0.0D+0) THEN
                  RPANC(SONDUE,TIDUE) = BUFFER(I,J)
                  SONDUE = SONDUE - 1
                  TIDUE = TIDUE + 1
                ENDIF
             ENDDO
             IF (SONDUE.EQ.SONUNO) SONUNO = SONUNO - 1
           ENDIF
        ENDDO
        SONUNO = 0
        DO I2 = 1,NCOL
           I = NCOL + 1 - I2
           IF (BISEC(I).NE.0.0D+0) THEN
             SONUNO = SONUNO + 1
             TET(SONUNO) = SET2(I)
           ENDIF
        ENDDO
        WINDOW = 0
        DO I = 1,NCOL
           IF (BISEC(I).NE.0.0D+0) THEN
             I2 = I
             GO TO 3
           ENDIF
        ENDDO

  3     SONUNO = NORM + I2
        DO I = I2,INDICE
           IF (BISEC(I+1).EQ.0.0D+0) THEN
             SONDUE = 1
             WINDOW = RANGE
             IF (I.LT.RANGE) WINDOW = I + 1
             DO J = 2,WINDOW
                STORE = I - J + 2
                IF (BISEC(STORE).NE.0.0D+0) THEN
                  SET3(SONDUE) = BUFFER(STORE,J)
                  SONDUE = SONDUE + 1
                ENDIF
             ENDDO
             DO J = SONDUE,RANGE
                SET3(J) = 0
             ENDDO
             J = SONUNO - I
             SONUNO = SONUNO + 1
             IWID = 1.0D0
             DO L = J,NORM
                IF (IWID.EQ.0.0D0) GO TO 4
                POS = SET3(1)
                S = IWID*POS
                IF (S*POS.NE.0.0D+0) THEN
                  WINDOW = NORM - L + 1
                  IF (WINDOW.GT.RANGE) WINDOW = RANGE
                  D = DSASSO(L)
                  IF (D.EQ.0.0D+0) THEN
                    DSASSO(L) = S*POS
                    CROLL = 0
                    SROLL = 1.0D0/POS
                  ELSE
                    GIU = D + S*POS
                    DSASSO(L) = GIU
                    CROLL = D/GIU
                    SROLL = S/GIU
                  ENDIF
                  IWID = IWID*CROLL
                  IF (WINDOW.GE.2) THEN
                    DO Z = 2,WINDOW
                       OLDCOL = RPANC(L,Z)
                       OLDROW = SET3(Z)
                       RPANC(L,Z) = CROLL*OLDCOL + SROLL*OLDROW
                       SET3(Z-1) = OLDROW - POS*OLDCOL
                    ENDDO
                  ENDIF
                ELSE
                  WINDOW = NORM - L + 1
                  IF (WINDOW.GT.RANGE) WINDOW = RANGE
                  IF (WINDOW.GE.2) THEN
                    DO Z = 2, WINDOW
                       SET3(Z-1) = SET3(Z)
                    ENDDO
                  ENDIF
                ENDIF
                SET3(WINDOW) = 0
             ENDDO
           ENDIF
 4         CONTINUE
        ENDDO
        L = 0
        DO I = 1,NORM
           IF (L.LT.RANGE) L = I
           S = TET(I)
           SONUNO = I
           IF (L.GE.2) THEN
             DO J = 2,L
                SONUNO = SONUNO - 1
                S = S - RPANC(SONUNO,J)*TET(SONUNO)
             ENDDO
           ENDIF
           TET(I) = S
        ENDDO
        L = 0
        DO J2 = 1,NORM
           J = NORM + 1 - J2
           IF (L.LT.RANGE) L = L + 1
           SONUNO = J - 1
           S = TET(J)/DSASSO(J)
           IF (L.GE.2) THEN
             DO I = 2,L
                STORE = I + SONUNO
                S = S - RPANC(J,I)*TET(STORE)
             ENDDO
           ENDIF
           TET(J) = S
        ENDDO
        SONUNO = NORM + 1
        WINDOW = 0
        DO I = 1,NCOL
           SONDUE = SONUNO
           S = 0
           IF (BISEC(I).NE.0.0D0) THEN
             SONUNO = SONUNO - 1
             S = TET(SONUNO)
           ENDIF
           IF (WINDOW.LT.RANGE) WINDOW = I
           IF (WINDOW.GE.2) THEN
              DO J = 2,WINDOW
                 STORE = I - J + 1
                 IF (BISEC(STORE).NE.0.0D+0) THEN
                   S = S + BUFFER(STORE,J)*TET(SONDUE)
                   SONDUE = SONDUE + 1
                 ENDIF
              ENDDO
           ENDIF
           SET1(I) = S
        ENDDO
        DO I = 1,NCOL
           IF (BISEC(I).EQ.0.0D+0) THEN
             S = SET2(I)
             IF (I.NE.NCOL) THEN
               WINDOW = NCOL - I + 1
               IF (WINDOW.GT.RANGE) WINDOW = RANGE
               DO J = 2,WINDOW
                  INDICE = I + J - 1
                  S = S - SET1(INDICE)*BUFFER(I,J)
               ENDDO
             ENDIF
             QUADRO=QUADRO+MENEFR*DUMP(I)*SET1(I)*(SET1(I)-2.0D+0*S)
           ENDIF
        ENDDO
      ELSE
        L = 0
        DO J2 = 1,NCOL
           J = NCOL + 1 - J2
           IF (L.LT.RANGE) L = L + 1
           Z = J - 1
           S = SET2(J)
           IF (L.GE.2) THEN
             DO I = 2,L
                STORE = I + Z
                S = S - BUFFER(J,I)*SET1(STORE)
             ENDDO
           ENDIF
           SET1(J) = S
        ENDDO
      ENDIF
      IERR = 0
      VARIA2 = QUADRO
      
C
      RETURN
      END     
