! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
subroutine wrinfo(istat)

  use errorHandling 
  use global

  implicit none

  integer istat
  real tmpsum

!!    new informational output about input and output count numbers  (2016/01)
!!    Update 2017/01: Cheesed image is now created /after/ subtraction of OOTs.
!!    We need to add oot_sky here in order to get the correct numbers.
  if (verbosity(AppMsg) >= Verbose) then
     tmpsum = sum(iches(1:ipa_x,1:ipa_y))
     if (withoot) then
        if (idinst .eq. 1) then
           tmpsum = sum(iches(1:ipa_x,1:ipa_y) &
                + oot_sky(1:ipa_x,1:ipa_y) * MFELD(1:ipa_x,1:ipa_y))
        endif
     endif

     write(errstr,*) &
          "Total number of counts in cheesed input image:    ", &
          tmpsum
     call message(AppMsg,Verbose)
     write(errstr,*) &
          "Total number of counts in cheesed background map: ", &
          sum(iback(1:ipa_x,1:ipa_y)*mfeld(1:ipa_x,1:ipa_y))
     call message(AppMsg,Verbose)
  endif

  return
end

